# all files / diagram-js/lib/features/move/ Move.js

82.09% Statements 55/67
66.67% Branches 16/24
90.91% Functions 10/11
82.09% Lines 55/67

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    233
    234
    235
    236
    237
    238
    239
    240
    241
    242
    243
    244
    245
    246
    247
    248
    249
    250

    1×
    1×
    1×

    1×

    52×

    129×

    254×

    52×
    52×
    52×

    52×
    34×

    52×

    52×

    254×

    52×
    52×

    52×

    52×

    254×

    77×
    77×
    77×
    77×
    77×

    77×

    77×
    77×

    77×

    77×

    254×

    35×

    35×
    35×
    35×
    35×

    35×
    1×

    34×
    34×

    34×

    34×

    254×

    52×

    52×

    52×

    52×

    52×

    254×

    1×

    52×

    52×
    65×

    102×

    65×

     import {
      assign,
      filter,
      groupBy,
      isObject
    } from 'min-dash';

    var LOW_PRIORITY = 500,
        MEDIUM_PRIORITY = 1250,
        HIGH_PRIORITY = 1500;

    import { getOriginal as getOriginalEvent } from '../../util/Event';

    var round = Math.round;

    function mid(element) {
      return {
        x: element.x + round(element.width / 2),
        y: element.y + round(element.height / 2)
      };
    }

    /**
     * A plugin that makes shapes draggable / droppable.
     *
     * @param {EventBus} eventBus
     * @param {Dragging} dragging
     * @param {Modeling} modeling
     * @param {Selection} selection
     * @param {Rules} rules
     */
    export default function MoveEvents(
        eventBus, dragging, modeling,
        selection, rules) {

      // rules

      function canMove(shapes, delta, position, target) {

        return rules.allowed('elements.move', {
          shapes: shapes,
          delta: delta,
          position: position,
          target: target
        });
      }

      // move events

      // assign a high priority to this handler to setup the environment
      // others may hook up later, e.g. at default priority and modify
      // the move environment.
      //
      // This sets up the context with
      //
      // * shape: the primary shape being moved
      // * shapes: a list of shapes to be moved
      // * validatedShapes: a list of shapes that are being checked
      //                    against the rules before and during move
      //
      eventBus.on('shape.move.start', HIGH_PRIORITY, function(event) {

        var context = event.context,
            shape = event.shape,
            shapes = selection.get().slice();

        // move only single shape if the dragged element
        // is not part of the current selection
        if (shapes.indexOf(shape) === -1) {
          shapes = [ shape ];
        }

        // ensure we remove nested elements in the collection
        // and add attachers for a proper dragger
        shapes = removeNested(shapes);

        // attach shapes to drag context
        assign(context, {
          shapes: shapes,
          validatedShapes: shapes,
          shape: shape
        });
      });

      // assign a high priority to this handler to setup the environment
      // others may hook up later, e.g. at default priority and modify
      // the move environment
      //
      eventBus.on('shape.move.start', MEDIUM_PRIORITY, function(event) {

        var context = event.context,
            validatedShapes = context.validatedShapes,
            canExecute;

        canExecute = context.canExecute = canMove(validatedShapes);

        // check if we can move the elements
        Iif (!canExecute) {
          return false;
        }
      });

      // assign a low priority to this handler
      // to let others modify the move event before we update
      // the context
      //
      eventBus.on('shape.move.move', LOW_PRIORITY, function(event) {

        var context = event.context,
            validatedShapes = context.validatedShapes,
            hover = event.hover,
            delta = { x: event.dx, y: event.dy },
            position = { x: event.x, y: event.y },
            canExecute;

        // check if we can move the elements
        canExecute = canMove(validatedShapes, delta, position, hover);

        context.delta = delta;
        context.canExecute = canExecute;

        // simply ignore move over
        Iif (canExecute === null) {
          context.target = null;

          return;
        }

        context.target = hover;
      });

      eventBus.on('shape.move.end', function(event) {

        var context = event.context;

        var delta = context.delta,
            canExecute = context.canExecute,
            isAttach = canExecute === 'attach',
            shapes = context.shapes;

        if (canExecute === false) {
          return false;
        }

        // ensure we have actual pixel values deltas
        // (important when zoom level was > 1 during move)
        delta.x = round(delta.x);
        delta.y = round(delta.y);

        Iif (delta.x === 0 && delta.y === 0) {

          // didn't move
          return;
        }

        modeling.moveElements(shapes, delta, context.target, {
          primaryShape: context.shape,
          attach: isAttach
        });
      });

      // move activation

      eventBus.on('element.mousedown', function(event) {

        var originalEvent = getOriginalEvent(event);

        if (!originalEvent) {
          throw new Error('must supply DOM mousedown event');
        }

        return start(originalEvent, event.element);
      });

      /**
       * Start move.
       *
       * @param {MouseEvent} event
       * @param {djs.model.Shape} shape
       * @param {boolean} [activate]
       * @param {Object} [context]
       */
      function start(event, element, activate, context) {
        Iif (isObject(activate)) {
          context = activate;
          activate = false;
        }

        // do not move connections or the root element
        Iif (element.waypoints || !element.parent) {
          return;
        }

        var referencePoint = mid(element);

        dragging.init(event, referencePoint, 'shape.move', {
          cursor: 'grabbing',
          autoActivate: activate,
          data: {
            shape: element,
            context: context || {}
          }
        });

        // we've handled the event
        return true;
      }

      // API

      this.start = start;
    }

    MoveEvents.$inject = [
      'eventBus',
      'dragging',
      'modeling',
      'selection',
      'rules'
    ];

    /**
     * Return a filtered list of elements that do not contain
     * those nested into others.
     *
     * @param  {Array<djs.model.Base>} elements
     *
     * @return {Array<djs.model.Base>} filtered
     */
    function removeNested(elements) {

      var ids = groupBy(elements, 'id');

      return filter(elements, function(element) {
        while ((element = element.parent)) {

          // parent in selection
          Iif (ids[element.id]) {
            return false;
          }
        }

        return true;
      });
    }